library(sampling)
library(plotrix)
library(labstatR)
library(car)
library(MASS)
library(userfriendlyscience)
library(Publish)

#myrnorm <- function(n, m, s, lwr, upr, rounding) {
  samp <- round(rnorm(n, m, s), rounding)
  samp[samp < lwr] <- lwr
  samp[samp > upr] <- upr
  samp
}
#carbonio<-myrnorm(n=64, m=60, s=38.56, lwr=3.158, upr=96, rounding=3)
#province<-rep(1:16, each=4)
#aree<-rep(1:4,each=16)
#sample<-seq(1:64)

#dati_carbonio<-data.frame(carbonio,province,aree,sample)
#View(dati_carbonio)
#dati_carbonio$province<-factor(dati_carbonio$province)
#dati_carbonio$aree<-factor(dati_carbonio$aree)
#dati_carbonio$sample<-factor(dati_carbonio$sample)
#str(dati_carbonio)

carb_profili<-function(dataset, randomizzazioni)
{
  
  N<-randomizzazioni
  n_row<-length(dataset)
  profili<-array(dim = c(n_row, N))  
  results<-seq(1:n_row)  
  for(j in 1:N){
    resampled<-sample(dataset, n_row)  
    for(i in 2:n_row)
    {
      abc<-std.error(resampled[1:i])
      results[i]<-abc
    }
    profili[,j]<-results
  }
  finale<-data.frame(profili)
  print(finale)
}
profili<-carb_profili(dati_carbonio$carbonio,500)
rowmean<-rowMeans(profili)
par(family="serif", cex.lab=2.5,cex.axis=2,mai=c(1,1,1,1))
par(mfrow=c(1,1))
par(cex=0.6)
plot(rowmean[-1],ylab="Standard error",cex.lab=1, pch=19, xlab="Number of samples",ylim=range(c(2,15)))

random_sampling<-function (dataset,naree,nprovince,areexprovince,permu){
  
  
  results<-array(dim=c(4,3))
  
  for (p in 1:4){
    risultati<-array(dim=c(permu,3))
    for (j in 1:permu){
      resample<-mstage(dataset, stage=list("cluster","cluster","cluster"), varnames=list("aree","province","sample"), size=list(naree,c(rep(nprovince,naree)),c(rep(p,areexprovince))), method=list("srswor","srswor","srswor"))
      x<-getdata(dataset, resample)[[3]]
      
      media_carbonio<-mean(x$carbonio)
      cv_carbonio<-cv(x$carbonio)
      se_carbonio<-std.error(x$carbonio)
      
      risultati[j,1]=media_carbonio
      risultati[j,2]=se_carbonio
      risultati[j,3]=cv_carbonio
      
    }
    
    
    final<-data.frame(risultati)
    colnames(final)<-c("media_carbonio","se_carbonio","cv_carbonio")
    
    
    mcarbonio<-mean(final$media_carbonio)
    cvcarbonio<-mean(final$cv_carbonio)
    stderrcarbonio<-mean(final$se_carbonio)
    #n.plots<-rep(n, 10)
    
    results[p,1]=mcarbonio
    results[p,2]=stderrcarbonio
    results[p,3]=cvcarbonio
  }
  
  tabella<-data.frame(results)
  colnames(tabella)<-c("m_carbonio","se_carbonio","cv_carbonio")
  tabella$intensity<-c(1:4)
  tabella$naree<-rep(naree, 4)
  tabella$nprovince<-rep(nprovince,4)
  print(tabella)
  
}

prova1.1<-random_sampling(dati_carbonio,1,1,1,5)
prova1.4<-random_sampling(dati_carbonio,1,4,4,5)
prova2.1<-random_sampling(dati_carbonio,2,1,2,5)
prova2.4<-random_sampling(dati_carbonio,2,4,8,5)
prova3.1<-random_sampling(dati_carbonio,3,1,3,5)
prova3.4<-random_sampling(dati_carbonio,3,4,12,5)
prova4.1<-random_sampling(dati_carbonio,4,1,4,5)
prova4.4<-random_sampling(dati_carbonio,4,4,16,5)


finale<-rbind(prova1.1,prova1.4,prova2.1,prova2.4,prova3.1,prova3.4,prova4.1,prova4.4)
str(finale)
finale$naree<-factor(finale$naree)
finale$nprovince<-factor(finale$nprovince)
par(mfrow=c(1,3))
boxplot(m_carbonio~naree*nprovince, data=finale,ylab="Carbonio, ton/ha",xlab="Aree.Province")
boxplot(se_carbonio~naree*nprovince, data=finale,ylab="SE, standard error",xlab="Aree.Province")
boxplot(cv_carbonio~naree*nprovince, data=finale,ylab="CV, coefficient of variation",xlab="Aree.Province")


